from datetime import datetime
from typing import List, Optional, Dict, Any

from janis_core import *
from janis_core.types.common_data_types import String, Boolean, File, Int

Bcftools_Norm_V0_1_0 = CommandToolBuilder(tool="bcftools_norm", base_command=["bcftools", "norm"], inputs=[ToolInput(tag="in_check_ref", input_type=String(optional=True), prefix="--check-ref", doc=InputDocumentation(doc="check REF alleles and exit (e), warn (w), exclude (x), or set (s) bad sites [e]")), ToolInput(tag="in_remove_duplicates", input_type=Boolean(optional=True), prefix="--remove-duplicates", doc=InputDocumentation(doc="remove duplicate lines of the same type.")), ToolInput(tag="in_rm_dup", input_type=String(optional=True), prefix="--rm-dup", doc=InputDocumentation(doc="remove duplicate snps|indels|both|all|exact")), ToolInput(tag="in_fast_a_ref", input_type=File(optional=True), prefix="--fasta-ref", doc=InputDocumentation(doc="reference sequence")), ToolInput(tag="in_force", input_type=Boolean(optional=True), prefix="--force", doc=InputDocumentation(doc="try to proceed even if malformed tags are encountered. Experimental, use at your own risk")), ToolInput(tag="in_keep_sum", input_type=Boolean(optional=True), prefix="--keep-sum", doc=InputDocumentation(doc="<tag,..>           keep vector sum constant when splitting multiallelics (see github issue #360)")), ToolInput(tag="in_multi_allelic_s", input_type=Boolean(optional=True), prefix="--multiallelics", doc=InputDocumentation(doc="<-|+>[type]   split multiallelics (-) or join biallelics (+), type: snps|indels|both|any [both]")), ToolInput(tag="in_no_version", input_type=Boolean(optional=True), prefix="--no-version", doc=InputDocumentation(doc="do not append version and command line to the header")), ToolInput(tag="in_do_not_normalize", input_type=Boolean(optional=True), prefix="--do-not-normalize", doc=InputDocumentation(doc="do not normalize indels (with -m or -c s)")), ToolInput(tag="in_output", input_type=File(optional=True), prefix="--output", doc=InputDocumentation(doc="write output to a file [standard output]")), ToolInput(tag="in_output_type", input_type=String(optional=True), prefix="--output-type", doc=InputDocumentation(doc="'b' compressed BCF; 'u' uncompressed BCF; 'z' compressed VCF; 'v' uncompressed VCF [v]")), ToolInput(tag="in_regions", input_type=String(optional=True), prefix="--regions", doc=InputDocumentation(doc="restrict to comma-separated list of regions")), ToolInput(tag="in_regions_file", input_type=File(optional=True), prefix="--regions-file", doc=InputDocumentation(doc="restrict to regions listed in a file")), ToolInput(tag="in_strict_filter", input_type=Boolean(optional=True), prefix="--strict-filter", doc=InputDocumentation(doc="when merging (-m+), merged site is PASS only if all sites being merged PASS")), ToolInput(tag="in_targets", input_type=String(optional=True), prefix="--targets", doc=InputDocumentation(doc="similar to -r but streams rather than index-jumps")), ToolInput(tag="in_targets_file", input_type=File(optional=True), prefix="--targets-file", doc=InputDocumentation(doc="similar to -R but streams rather than index-jumps")), ToolInput(tag="in_threads", input_type=Int(optional=True), prefix="--threads", doc=InputDocumentation(doc="use multithreading with <int> worker threads [0]")), ToolInput(tag="in_site_win", input_type=Int(optional=True), prefix="--site-win", doc=InputDocumentation(doc="buffer for sorting lines which changed position during realignment [1000]")), ToolInput(tag="in_in_dot_vcf_do_tgz", input_type=String(), position=0, doc=InputDocumentation(doc=""))], outputs=[ToolOutput(tag="out_output", output_type=File(optional=True), selector=InputSelector(input_to_select="in_output", type_hint=File()), doc=OutputDocumentation(doc="write output to a file [standard output]"))], container="quay.io/biocontainers/bcftools:1.11--h7c999a4_0", version="v0.1.0")


if __name__ == "__main__":
    # or "cwl"
    Bcftools_Norm_V0_1_0().translate("wdl")

